//ここで使用する線路を指定してください．
local tr_front = "BBE_front"
local tr_back = "BBE_back"
//線路名指定，ここまで．

function get_desc(waytype,name) {
  local sts = [st_flat, st_elevated, st_tram]
  foreach (st in sts) {
    local desc_all = way_desc_x.get_available_ways(waytype, st)
    foreach (desc in desc_all) {
      if(desc.get_name()==name) {
        return desc
      }
    }
  }
  return null
}

function get_straight_way(start, end) {
	local pos = coord3d(start.x, start.y, start.z)
	local route = [coord3d(pos.x, pos.y, pos.z)]
	while(pos.x!=end.x || pos.y!=end.y) {
		// shortest way
		if(abs(pos.x-end.x)>=abs(pos.y-end.y)) {
			pos.x = (pos.x>end.x) ? pos.x - 1 : pos.x + 1
		}
		else {
		 	pos.y = (pos.y>end.y) ? pos.y - 1 : pos.y + 1
		}
		route.append(coord3d(pos.x, pos.y, pos.z))
	}
	return route
}

function is_front(route, idx) {
	local dc = coord3d(0,0,0)
	if(idx > 0) {
		dc += (route[idx] - route[idx-1])
	}
	if(idx < route.len()-1) {
		dc += (route[idx+1] - route[idx])
	}
	return dc.x==0 ? (dc.y > 0) : (dc.x < 0)
}

function do_work(player, start, end) {
	local desc_names = [tr_front, tr_back]
	local descs = [] // front, center, back
	foreach (name in desc_names) {
		local d = get_desc(wt_rail, name)
		if(d==null) {
			return "desc " + name + " is not found."
		}
		descs.append(d)
	}
	local route = get_straight_way(start, end)
	for(local i = 0; i < route.len()-1; i++) {
		local desc = is_front(route, i) ? descs[0] : descs[1]
		command_x.build_way(player, route[i], route[i+1], desc, true)
	}
}

function mark_tiles(player, start, end)
{
	local route = get_straight_way(start, end)
	foreach (p in route) {
		mark_tile(p)
	}
}
